from wooly import *
from wooly.widgets import *
from wooly.resources import *

from cumin import *
from cumin.objecttask import *
from cumin.util import *

from model import *
from pool import *
from test import *

strings = StringCatalog(__file__)

class Module(CuminModule):
    def __init__(self, app, name):
        super(Module, self).__init__(app, name)

        self.job_submit = JobSubmit(app)
        self.dag_job_submit = DagJobSubmit(app)
        self.vm_job_submit = VmJobSubmit(app)

        # cls = app.model.com_redhat_grid.Job

        # JobHold(self, cls)
        # JobRelease(self, cls)
        # JobRemove(self, cls)
        # JobSetAttribute(self, cls)

        # cls = app.model.com_redhat_grid.Negotiator

        # NegotiatorEditDynamicQuota(self, cls)
        # NegotiatorEditStaticQuota(self, cls)
        # NegotiatorEditPrioFactor(self, cls)
        # NegotiatorUserPrioFactor(self, cls)
        # NegotiatorEditRegroup(self, cls)
        # NegotiatorUserRegroup(self, cls)
        # NegotiatorAddGroup(self, cls)

    def init(self):
        super(Module, self).init()

        self.frame = GridFrame(self.app, "grid")
        self.app.main_page.main.grid = self.frame
        self.app.main_page.main.add_tab(self.frame)

        self.pool_slots_page = PoolSlotMapPage(self.app, "poolslots.vis")
        self.app.add_page(self.pool_slots_page)

        self.pool_slots_fullpage = PoolSlotFullPage \
            (self.app, "poolslotsfull.vis")
        self.app.add_page(self.pool_slots_fullpage)

    def init_test(self, test):
        GridTest("grid", test)

class GridFrame(CuminFrame):
    def __init__(self, app, name):
        super(GridFrame, self).__init__(app, name)

        self.view = GridView(app, "view")
        self.add_mode(self.view)

        self.pool = PoolFrame(app, "pool")
        self.add_mode(self.pool)
        # XXX self.add_sticky_view(self.pool)

    def render_title(self, session):
        return "Grid"

class GridView(Widget):
    def __init__(self, app, name):
        super(GridView, self).__init__(app, name)

        heading = self.Heading(app, "heading")
        self.add_child(heading)

        self.tabs = TabbedModeSet(app, "tabs")
        self.add_child(self.tabs)

        self.pools = PoolSelector(app, "pools")
        self.tabs.add_tab(self.pools)

    class Heading(CuminHeading):
        def render_title(self, session):
            return "Grid"

        def render_icon_href(self, session):
            return "resource?name=pool-36.png"
