try:
    from collections import defaultdict
except ImportError:
    class defaultdict(dict):
        def __init__(self, default_factory=None):
            super(dict, self).__init__()

            self.default_factory = default_factory

        def __getitem__(self, key):
            try:
                dict.__getitem__(self, key)
            except KeyError:
                if self.default_factory is None:
                    raise
                else:
                    return self.default_factory()

from collections import *
