import logging

levels = {
    "debug": logging.DEBUG,
    "info": logging.INFO,
    "warn": logging.WARN,
    "error": logging.ERROR,
    "critical": logging.CRITICAL
    }

def enable_logging(name, level, file):
    assert level
    assert file

    if type(level) is str:
        level = levels[level.lower()]

    if type(file) is str:
        file = open(file, "a")

    handler = logging.StreamHandler(file)

    fmt = "%(process)d %(asctime)s %(levelname)s %(message)s"
    handler.setFormatter(logging.Formatter(fmt))
    handler.setLevel(level)

    log = logging.getLogger(name)
    log.setLevel(logging.DEBUG)
    log.addHandler(handler)
