import logging
import os
import random
import sys
import time

from cStringIO import StringIO
from datetime import datetime
from traceback import print_exc

def unique_id():
    bits0 = random.getrandbits(32)
    bits1 = random.getrandbits(32)
    bits2 = random.getrandbits(32)
    bits3 = random.getrandbits(32)

    return "%08x-%08x-%08x-%08x" % (bits0, bits1, bits2, bits3)

try:
    from collections import defaultdict
except ImportError:
    class defaultdict(dict):
        def __init__(self, default_factory=None):
            super(dict, self).__init__()

            self.default_factory = default_factory

        def __getitem__(self, key):
            try:
                super(dict, self).__getitem__(key)
            except KeyError:
                if self.default_factory is None:
                    raise
                else:
                    return self.default_factory()

class Writer(object):
    def __init__(self):
        self.writer = StringIO()

    def write(self, string):
        self.writer.write(string)

    def to_string(self):
        string = self.writer.getvalue()

        self.writer.close()

        return string
